/* Altera FPGAs passive serial loader v0.2 2006/09/25 */
/* stellae (Noel LEMOUEL) / released under GPL */

#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <sys/types.h>
#include "hal.h"

#define SOFTWARE_VERSION         "pserial/0.2 sep2006"

#define CFG_EXTRA_TICKS          10    /* Acex 1K device */

/* ----- global Vars. ----- */
static char* argv0;

/* ------- forwards ------- */
static void usage ( void );

int main(int argc , char ** argv)
{
   FILE* f_stdin;
   struct stat f_info;

   unsigned char rbf_section[128];
   unsigned char acq_length;

   unsigned char i;
   unsigned long prgm_progress; /* debug */

   argv0 = argv[0];
   if (argc != 2)
   {
      usage();
      return -1;
   }

   /* test if file is a directory */
   if ((f_stdin = fopen(argv[1], "r")) == NULL)
   {
       (void) fprintf( stderr, "error: '%s' open failed\r\n", argv[0]);
       exit(-1);
   }

   stat(argv[1], &f_info);    /* stat follows sym. links */

   printf("size : %ld bytes\r\n", (long)f_info.st_size);

   /* fpga ps configuration */

   printf("HAL init\r\n");
   HAL_init();

   if (HAL_read_conf_done())
   {
      printf("CONF_DONE high\r\n");
   }else{
      printf("CONF_DONE low\r\n");
   }

   printf("strobe nCONFIG\r\n");
   HAL_strobe_nCONFIG();

   prgm_progress = 0; /* debug */
   printf("send program bits\r\n");
   acq_length = fread(rbf_section,1,128,f_stdin);
   while (acq_length > 0)
   {
      /* printf("%d", acq_length); */
      /* send bytes here */
      for(i=0; i<acq_length; i++)
      {
         HAL_shift_byte(rbf_section[i]);
         putc(0x0d, stdout);              /* debug */
         printf("%ld", prgm_progress);    /* debug */
         prgm_progress++ ;
      }
      acq_length = fread(rbf_section,1,128,f_stdin);
   }
   printf("\r\n");

   if (HAL_read_conf_done())
   {
      printf("CONF_DONE high\r\n");
   }else{
      printf("CONF_DONE low\r\n");
   }

   HAL_sample_extra_tick(10);

   if (HAL_read_init_done())
   {
      printf("INIT_DONE high\r\n");
   }else{
      printf("INIT_DONE low\r\n");
   }

   fclose(f_stdin);

   return 0;
}

static void
usage ( void )
{
   (void) fprintf( stderr, "usage: %s [rbf_file_name]\r\n", argv0 );
   exit(1);
}
